createStoreContext

Function: createStoreContext()

ts
function createStoreContext<TValue>(): object;
function createStoreContext<TValue>(): object;

Defined in: packages/angular-store/src/createStoreContext.ts:48

Creates a typed Angular dependency-injection context for sharing a bundle of atoms and stores with a component subtree.

The returned provideStoreContext function accepts a factory that creates the context value. Using a factory (rather than a static value) ensures each component instance — and each SSR request — receives its own state, avoiding cross-request pollution.

Consumers call injectStoreContext() inside an injection context (typically a constructor or field initializer) to retrieve the contextual atoms and stores, then compose them with existing hooks like injectSelector, injectSelector, and injectAtom.

Type Parameters

TValue

TValue extends object

Returns

object

injectStoreContext()

ts
injectStoreContext: () => TValue;
injectStoreContext: () => TValue;

Returns

TValue

provideStoreContext()

ts
provideStoreContext: (factory) => Provider;
provideStoreContext: (factory) => Provider;

Parameters

factory

() => TValue

Returns

Provider

Example

ts
const { provideStoreContext, injectStoreContext } = createStoreContext<{
  countAtom: Atom<number>
  totalsStore: Store<{ count: number }>
}>()

// Parent component provides the context
@Component({
  providers: [
    provideStoreContext(() => ({
      countAtom: createAtom(0),
      totalsStore: new Store({ count: 0 }),
    })),
  ],
  template: `<child-cmp />`,
})
class ParentComponent {}

// Child component consumes the context
@Component({ template: `{{ count() }}` })
class ChildComponent {
  private ctx = injectStoreContext()
  count = injectSelector(this.ctx.countAtom)
}
const { provideStoreContext, injectStoreContext } = createStoreContext<{
  countAtom: Atom<number>
  totalsStore: Store<{ count: number }>
}>()

// Parent component provides the context
@Component({
  providers: [
    provideStoreContext(() => ({
      countAtom: createAtom(0),
      totalsStore: new Store({ count: 0 }),
    })),
  ],
  template: `<child-cmp />`,
})
class ParentComponent {}

// Child component consumes the context
@Component({ template: `{{ count() }}` })
class ChildComponent {
  private ctx = injectStoreContext()
  count = injectSelector(this.ctx.countAtom)
}

Throws

When injectStoreContext() is called without a matching provideStoreContext() in a parent component's providers.

Subscribe to Bytes

Your weekly dose of JavaScript news. Delivered every Monday to over 100,000 devs, for free.

Bytes

No spam. Unsubscribe at any time.

createStoreContext

Function: createStoreContext()

ts
function createStoreContext<TValue>(): object;
function createStoreContext<TValue>(): object;

Defined in: packages/react-store/src/createStoreContext.tsx:40

Creates a typed React context for sharing a bundle of atoms and stores with a subtree.

The returned StoreProvider only transports the provided object through React context. Consumers destructure the contextual atoms and stores, then compose them with the existing hooks like useSelector, useSelector and useAtom.

The object shape is preserved exactly, so keyed atoms and stores remain fully typed when read back with useStoreContext().

Type Parameters

TValue

TValue extends object

Returns

object

StoreProvider()

ts
StoreProvider: (props) => ReactElement;
StoreProvider: (props) => ReactElement;

Parameters

props

object & object

Returns

ReactElement

useStoreContext()

ts
useStoreContext: () => TValue;
useStoreContext: () => TValue;

Returns

TValue

Example

tsx
const { StoreProvider, useStoreContext } = createStoreContext<{
  countAtom: Atom<number>
  totalsStore: Store<{ count: number }>
}>()

function CountButton() {
  const { countAtom, totalsStore } = useStoreContext()
  const count = useSelector(countAtom)
  const total = useSelector(totalsStore, (state) => state.count)

  return (
    <button
      type="button"
      onClick={() => totalsStore.setState((state) => ({ ...state, count: state.count + 1 }))}
    >
      {count} / {total}
    </button>
  )
}
const { StoreProvider, useStoreContext } = createStoreContext<{
  countAtom: Atom<number>
  totalsStore: Store<{ count: number }>
}>()

function CountButton() {
  const { countAtom, totalsStore } = useStoreContext()
  const count = useSelector(countAtom)
  const total = useSelector(totalsStore, (state) => state.count)

  return (
    <button
      type="button"
      onClick={() => totalsStore.setState((state) => ({ ...state, count: state.count + 1 }))}
    >
      {count} / {total}
    </button>
  )
}

Throws

When useStoreContext() is called outside the matching StoreProvider.

Subscribe to Bytes

Your weekly dose of JavaScript news. Delivered every Monday to over 100,000 devs, for free.

Bytes

No spam. Unsubscribe at any time.